//+------------------------------------------------------------------+
//|                                               VAR Calculator.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//---- input parameters
extern double    Lots=0;
extern double    Value_AT_Risk=0;
extern double    Dollars_AT_Risk=0;
extern double    Range=0;
extern double    EntryPoint=0;
extern double    StopLoss=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
double LotStep,Equity,PipValue,VAR,Dollars, BLots;
int LotDigit;
bool LotsLogic = false;
bool DollarsLogic = false;
bool VARLogic = false;
if(Lots==0 && Value_AT_Risk==0 && Dollars_AT_Risk==0)
{
Comment("You must enter a value for either Lots, Value_AT_Risk, or Dollars_AT_Risk");
return (0);
}
if( Range ==0 && (EntryPoint==0 || StopLoss==0))
{
Comment("You must enter a value for Range or both a EntryPoint and a StopLoss");
return(0);
}
if (Lots != 0)
LotsLogic = true;
if (Dollars_AT_Risk!=0)
DollarsLogic=true;
if(Value_AT_Risk!=0)
VARLogic = true;

LotStep=NormalizeDouble(MarketInfo(Symbol(),24),2);
if (LotStep==1) { LotDigit=0; }
if (LotStep==0.1) { LotDigit=1; }
if (LotStep==0.01) { LotDigit=2; }	
PipValue=MarketInfo(Symbol(),16);
Equity = AccountEquity();
if (Range  == 0)
{
if (EntryPoint>StopLoss)
Range = (EntryPoint-StopLoss)/Point;
else
Range = (StopLoss-EntryPoint)/Point;
}
if (Lots==0 && Value_AT_Risk!=0)
{
Lots=NormalizeDouble(((Equity*Value_AT_Risk)/100)/(Range*PipValue),LotDigit);

VAR=NormalizeDouble((Range*PipValue*Lots*100)/Equity,2);
}
if (Value_AT_Risk==0 && Lots!=0)
VAR=NormalizeDouble((Range*PipValue*Lots*100)/Equity,2);
if (Dollars_AT_Risk==0 && Lots!=0)
Dollars=NormalizeDouble((Range*PipValue*Lots),2);
if (Lots==0 && Value_AT_Risk==0)
{
Lots = NormalizeDouble(Dollars_AT_Risk/(Range*PipValue),LotDigit);
VAR = NormalizeDouble((Range*PipValue*Lots*100)/Equity,2);
Dollars=NormalizeDouble((Range*PipValue*Lots),2); 
}

//if (LotsLogic)	
Comment("Your Current Account Equity = ",Equity,"\nThe Pip value of ",Symbol(), " is ",PipValue, 
   "\n For a Range of ",Range ," Pips "," \n Your recommended LotSize should be ", Lots, "\n For a Value at Risk of ", 
   VAR,"%",  "\n Your Dollars at Risk is $",Dollars); 








//   Troubled area
/*

        
if(VARLogic)
{
if (VAR>Value_AT_Risk)
{
LotStep=NormalizeDouble(MarketInfo(Symbol(),24),2);
if (LotStep==1) { BLots=Lots-1; }
if (LotStep==0.1) { BLots=Lots-0.1; }
if (LotStep==0.01) { BLots=Lots-0.01; }	

Dollars=NormalizeDouble((Range*PipValue*BLots),2);
VAR=NormalizeDouble((Range*PipValue*BLots*100)/Equity,2);
}
if (VAR>Value_AT_Risk)
Comment("Your Current Account Equity = ",Equity,"\nThe Pip value of ",Symbol(), " is ",PipValue, 
   "\n For a Range of ",Range ," Pips "," \n Your LotSize should be ", Lots, "\n For a Value at Risk of ", 
   VAR,"%",  "\n Your Dollars at Risk is $",Dollars, " \nTo Stay within your requested Value at Risk with this brokers specifications a Lot Size of ", BLots , " is recommended",
   "\n This will give you a Value at risk of ", VAR,
   "\n and a dollar at risk of $",Dollars);    
   else
 Comment("Your Current Account Equity = ",Equity,"\nThe Pip value of ",Symbol(), " is ",PipValue, 
   "\n For a Range of ",Range ," Pips "," \n Your LotSize should be ", Lots, "\n For a Value at Risk of ", 
   VAR,"%",  "\n Your Dollars at Risk is $",Dollars);          
   }
   if(DollarsLogic)
{
if (Dollars>Dollars_AT_Risk)
{
if (LotStep==0.01)
Lots = BLots-0.01;
else if (LotStep==0.1)
Lots = BLots-0.1;
else if (LotStep==1)
Lots = BLots-1;
Dollars=NormalizeDouble((Range*PipValue*BLots),2);
VAR=NormalizeDouble((Range*PipValue*BLots*100)/Equity,2);


Comment("Your Current Account Equity = ",Equity,"\nThe Pip value of ",Symbol(), " is ",PipValue, 
   "\n For a Range of ",Range ," Pips "," \n Your LotSize should be ", Lots, "\n For a Value at Risk of ", 
   VAR,"%",  "\n Your Dollars at Risk is $",Dollars, " \nTo Stay within your requested Dollars at Risk with this brokers specifications a Lot Size of ", BLots , " is recommended",
   "\n This will give you a Value at risk of ", VAR,
   "\n and a Dollar at Risk of $",Dollars);   
   }
   else
   Comment("Your Current Account Equity = ",Equity,"\nThe Pip value of ",Symbol(), " is ",PipValue, 
   "\n For a Range of ",Range ," Pips "," \n Your LotSize should be ", Lots, "\n For a Value at Risk of ", 
   VAR,"%",  "\n Your Dollars at Risk is $",Dollars);      
      
   }
   
//----
//----
*/
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
/*
double LotStep,Equity,PipValue;
int LotDigit;
if(Lots==0 && VAR==0)
{
Comment("You must enter a value for either Lots or VAR");
return (0);
}
if( Range ==0 && (EntryPoint==0 || StopLoss==0))
{
Comment("You must enter a value for Range or both a EntryPoint and a StopLoss");
return(0);
}

LotStep=NormalizeDouble(MarketInfo(Symbol(),24),2);
if (LotStep==1) { LotDigit=0; }
if (LotStep==0.1) { LotDigit=1; }
if (LotStep==0.01) { LotDigit=2; }	
PipValue=MarketInfo(Symbol(),16);
Equity = AccountEquity();
if (Range  == 0)
{
if (EntryPoint>StopLoss)
Range = (EntryPoint-StopLoss)/Point;
else
Range = (StopLoss-EntryPoint)/Point;
}
if (Lots==0)
Lots=NormalizeDouble(((Equity*VAR)/100)/(Range*PipValue),LotDigit);
if (VAR==0)
VAR=(Range*PipValue*Lots)/Equity;
	
Comment("Your Current Account Equity = ",Equity,"\nThe Pip value of ",Symbol(), " is ",PipValue, "\n For a Range of ",Range ," Pips "," \n Your LotSize should be ", Lots, "\n For a Value at Risk of ", VAR,"%" );      
//----
*/
   return(0);
  }
//+------------------------------------------------------------------+